;**************************************************************************************
; PK Programmierpraktikum SS 99
; Gruppe: Noisternig M., Obermair C., Schmidbauer J., Stieglbauer G.
; 
; Projekt: Rug Warrior Communication
;
; Datei:
;   lcd_driv.asm
; 
; Typ:
;   LCD-Treiber
; 
; Beschreibung:   
;   Assembler-Routinen zur Ansteuerung des LCD-Displays.
;   
;   _LCDDriver
;   	Routine zur Uebertragung von Befehlen auf das LCD-Display.
;
;   _LCDCopy
;	Routine, die den Treiber in den richtigen Speicherbereich laedt
;
;
;  Plattform: 
;  Rug Warrior (Motorola 68HC11)
;
;*************************************************************************************
   

    .area   _LCD    (REL)

    .include    "reg6811.s"

    LCD_QUERY = 4

_LCDDriver::				;LCD-Treiberroutine
    std     LCDta-_LCDDriver+_LCDStart
    ldd     *ZD0			;Parameteruebergabe

    stx     LCDtw-_LCDDriver+_LCDStart
    ldx     #0h1000

    sei
    bclr    <HPRIO, x, #0b00100000
    bclr    <PORTA, x, #0b00010000

    staa    LCDtb-_LCDDriver+_LCDStart

    clr     <DDRC, x

    cmpa    #LCD_QUERY
    bne     LCDBusy

    ldaa    #1
    staa    PORTB

    bset    <PORTA, x, #0b00010000
    ldaa    <PORTC, x
    bclr    <PORTA, x, #0b00010000

    bra     LCDExit
    
LCDBusy:
    ldaa    #1
    staa    PORTB

    bset    <PORTA, x, #0b00010000
    ldaa    <PORTC, x
    bclr    <PORTA, x, #0b00010000

    anda    #0h80
    bne     LCDBusy

    ldaa    #0hff
    staa    <DDRC, x

    ldaa    LCDtb-_LCDDriver+_LCDStart
    staa    <PORTB, x
    stab    <PORTC, x

    bset    <PORTA, x, #0b00010000
    bclr    <PORTA, x, #0b00010000
    
LCDExit:
    bset    <HPRIO, x, #0b00100000
    ldx     LCDtw-_LCDDriver+_LCDStart    

LCDcli:
    cli
    rts

LCDtw:
    .blkw   1

LCDtb:
    .blkb   1

LCDta:
    .blkw   1

_LCDEnd::


_LCDCopy::			;Laderoutine fuer LCD-Treiber 
    stx     LCDtw
    sty     LCDta
    staa    LCDtb

    ldx     #_LCDDriver
    ldy     #_LCDStart

LCDloop:
    ldaa    0,  x
    staa    0,  y
    inx
    iny
    cpx     #_LCDEnd
    bne     LCDloop

    ldx     LCDtw
    ldy     LCDta
    ldaa    LCDtb

    rts
