/**************************************************************************************
 PK Programmierpraktikum SS 99
 Gruppe: Noisternig M., Obermair C., Schmidbauer J., Stieglbauer G.
 
 Projekt: Rug Warrior Communication
 
 Typ:
   Demoprogramm
 
 Beschreibung:   
   Programm welches ueber einen Pseudo-Zufallsgenerator gesteuert den
   Rug fahren laesst und dabei die jeweilige Richtung als Ton ausgibt.
   Dieser Ton wird vom Rug Slave verwendet um in die gleiche Richtung
   zu fahren.
   Gleichzeitig wird immer ueberprueft ob der Rug sich an einer Ladestation
   befindet. Wenn dies der Fall ist werden die Motoren gestoppt und der
   Rug spielt eine Melodie. Dann faehrt der Rug weiter.
   
   Dieses Programm benoetigt einen modifizierten Rug Warrior!
 
 Plattform: 
   Rug Warrior (Motorola 68HC11)

*****************************************************************************/

/* RUG Master 02.07.99 */
#pragma long_branch
#include <os.h>
#include <debug.h>
#include <reg6811.h>
#include <rug_lib.h>

/* Pseudozufallsgenerator fuer 8 Bit Zahlen */

unsigned char rnd(void)
{
  seed=seed*3001+12345;
  return (seed/256)%256;	
}

/* Hauptprogramm fuer den Rug Master */

void main()
{
  char i;
  signed char a;
  int j;
  signed char ml,mr;
  char geheim;

  /* Bei Programmstart eine Melodie spielen */
  closeencounters();

  /* AD-Wandler initialisieren */
  OPTION|=0x80;
  
  /* Pulsweitenmodulator fuer die Motoren initialisieren */
  init_pwm();
  
  /*init_LCD();
  cls_LCD();*/
  /*
  printstring("HALLO");
  trap();*/
  /*
  while(1)
  {
    ADCTL = 0x15;
    while(ADCTL & 0x80== 0);
    i = ADR2;
    
    for(j=0;j<10;j++) buffer[j]=0;
    buffer[0]='0'+i/100;
    buffer[1]='0'+(i%100)/10;
    buffer[2]='0'+(i%10);
    printstring(buffer);
  }*/
  
  for(i=0;i<33;i++) arrayc[i]=0;
  ml=mr=geheim=0;
  
  /* Hauptschleife */
  
  while(1)
  {
  	
    /*num2LED(0);*/
    /*os_disable();*/
  
    /* Testen ob aufgeladen wird */
    ADCTL = 0x15;
    while(ADCTL & 0x80== 0);
    i = ADR2;
    
    /* Wenn sich der Rug an der Ladestation befindet (ADC-Wert > 135) dann spiele
       eine Melodie */
       
    if(i>135) cof();
    
    /* Alle 10 Schritte brechne eine neue Richtung des Rugs via Zufallsgenerator */
    if(geheim>10)
    {
      j=rnd();    
      i=11;
      if(j<20) i=5;
      if(j>235) i=14;
      j=i;
      geheim=0;
      
    }   
    a=0;
    if(rnd()>220) a=10;
     
    
    /* Berechne die Aenderung der Motorgeschwindigkeit durch die neue Richtung 
       Wird verwendet um ein "ruckfreies" Fahren des Rugs zu erreichen */
    if(a>4 && j>0) 
    {
      if(j<10) 
      {
      	 ml=ml+(100-ml)/2;
      	 mr=mr-(100+mr)/2; 	 
      }
      else if(j>12)
      {
      	 ml=ml-(100+mr)/2;
      	 mr=mr+(100-mr)/2;
      	 geheim=0;
      }
      else
      {
      	 ml=ml+(100-ml)/2;
      	 mr=mr+(100-mr)/2;     
      }
    }
    else
    {
      /* Wenn keine Richtungsinformation vorliegt: langsamer werden */
      ml/=2;
      mr/=2;	
    }
    
    /* Berechnete Werte an Motor uebergeben */
    motor(0,ml);
    motor(1,mr);
    
    geheim++;
    
    /* Analog zur Fahrrichtung Ton Spielen damit der Rug Slave die
       Richtung bekommt */
    if(a>4 && j>0) 
    {
      if(j<10) 
        note(800,200);      
      else if(j>12)
        note(1800,200);
      else 
        note(1400,200);
    }

    
  }

}

