/**************************************************************************************
 PK Programmierpraktikum SS 99
 Gruppe: Noisternig M., Obermair C., Schmidbauer J., Stieglbauer G.
 
 Projekt: Rug Warrior Communication
 
 Typ:
   Demoprogramm
 
 Beschreibung:   
   Programm welches ueber das Mikrofon akustische Signale einliest und
   je nach Frequenz den Rug Warrior steuert.
   Mit diesem Programm kann ein Rug Warrior (Slave) vom Rug Master aus
   gesteuert werden indem dieser Tonsequenzen erzeugt.
 
 Plattform: 
   Rug Warrior (Motorola 68HC11)

*****************************************************************************/

/* DEMO Programm fr Slave RUG 02.07.99*/

#pragma long_branch
#include <os.h>
#include <debug.h>
#include <reg6811.h>
#include <rug_lib.h>

void main()
{
  char i;
  signed char a;
  int j;
  signed char ml,mr;
  char geheim;

  /* evtl. Kennmelodie spielen */
  /* closeencounters();*/

  /* AD-Wandler initialisieren */
  OPTION|=0x80;
  
  /* fft tabellen vorberechnen */
  fft_inittab();
  
  /* Motoransteuerung initialisieren */
  init_pwm();
    
  for(i=0;i<33;i++) arrayc[i]=0;
  ml=mr=geheim=0;
  
  /* Hauptschleife */
  while(1)
  {
  	
    /*num2LED(0);*/
    /*os_disable();*/
    
    /* Motoren deaktivieren, damit keine Stoerungen das Mikrofon beeinflussen*/
    motor(0,0);
    motor(1,0);
    
    /* Warten */
    for(j=0;j<1000;j++);
    
    /* 32 Werte vom Mikrofon einlesen */
    for(i=0;i<32;i++)
    {
      ADCTL = 0x12;
      while(ADCTL & CCF != 0);
      buffer[i] = (ADR3-128);
      for(j=0;j<10;j++);
    }
    
    /* Nochmal warten bevor die Motoren wieder aktiviert werden */
    for(j=0;j<255;j++);

    motor(0,ml);
    motor(1,mr);
    
    /*os_enable();*/
  
    /* Eingangsparameter fuer die FFT Transformation berechnen */
    for ( i = 1; i <= fftsize; i++ )
    {
       fft_z_r[i] = buffer[i-1];
       fft_z_i[i]=0;
    }
    
    /* FFT Transformation durchfuehren */
    fft();    
    
    /* Eventuell das Ergebnis (Spektrum) am Display anzeigen (langsam) */
    /*
    for(i=0;i<16;i++)
    {
      a=fft_z_r[i+1]+1;               
      if(a<0) {arrayc[i]=' '; arrayc[i+16]='N';}
      if(a==0) {arrayc[i]=' '; arrayc[i+16]=' '; }                                 
      if(a==1) {arrayc[i]=' '; arrayc[i+16]='.'; }
      if(a==2) {arrayc[i]=' '; arrayc[i+16]='+'; }
      if(a==3) {arrayc[i]=' '; arrayc[i+16]='*'; }
      if(a==4) {arrayc[i]=' '; arrayc[i+16]='#'; }
      if(a==5) {arrayc[i]=' '; arrayc[i+16]='X'; }
      if(a==6) {arrayc[i]='.'; arrayc[i+16]='X'; }
      if(a==7) {arrayc[i]='+'; arrayc[i+16]='X'; }
      if(a==8) {arrayc[i]='*'; arrayc[i+16]='X'; }
      if(a==9) {arrayc[i]='#'; arrayc[i+16]='X'; }
      if(a>=10){arrayc[i]='X'; arrayc[i+16]='X';}
    }

    printstring(arrayc);*/
    
    j=0;
    a=0;
    /* Staerkste Frequenz feststellen */
    for(i=2;i<16;i++)
      a=((fft_z_r[i])>a?(fft_z_r[j=i]):a);
        
    /* Richtung berechnen */
    if(a>4 && j>0) 
    {
      if(j<10) 
      {
      	 ml=ml+(100-ml)/2;
      	 mr=mr-(100+mr)/2;
      	 geheim++;
      }
      else if(j>12)
      {
      	 ml=ml-(100+mr)/2;
      	 mr=mr+(100-mr)/2;
      	 geheim=0;
      }
      else
      {
      	 ml=ml+(100-ml)/2;
      	 mr=mr+(100-mr)/2;
      	 geheim=0;
      }
    }
    else
    {
      ml/=2;
      mr/=2;	
    }
    
    /* Wenn die geheime Sequenz aktiviert wurde, Melodie spielen */
    if(geheim>5)
    {
      motor(0,0);
      motor(1,0);
      cof();
      geheim=0;	
    }
    
    /* Motor ansteuern */
    motor(0,ml);
    motor(1,mr);
    
    /* Ton mit proportionaler Frequenz zur Kontrolle selber spielen */
    if(a>4 && j>0) 
    {
      tone(j*120,200);
      while(TMSK1 & 0x08);
    }

    
  }

}

